org.apache.poi.hwpf.model.types

## Class FSPAAbstractType

- java.lang.Object
- - org.apache.poi.hwpf.model.types.FSPAAbstractType

- Direct Known Subclasses:
    FSPA

      @Internal
      public abstract class FSPAAbstractType
      extends java.lang.Object

  File Shape Address (FSPA).

  Class and fields descriptions are quoted from Microsoft Office Word 97-2007 Binary File Format

  NOTE: This source is automatically generated please do not modify this file. Either subclass or remove the record in src/types/definitions.

  This class is internal. It content or properties may change without notice due to changes in our knowledge of internal Microsoft Word binary structures.

  Author:
    Sergey Vladimirov; according to Microsoft Office Word 97-2007 Binary File Format Specification [*.doc]

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `field_1_spid`
    `protected int` | `field_2_xaLeft`
    `protected int` | `field_3_yaTop`
    `protected int` | `field_4_xaRight`
    `protected int` | `field_5_yaBottom`
    `protected short` | `field_6_flags`
    `protected int` | `field_7_cTxbx`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `FSPAAbstractType()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `fillFields(byte[] data, int offset)`
    `byte` | `getBx()` X position of shape relative to anchor CP
    `byte` | `getBy()` Y position of shape relative to anchor CP
    `int` | `getCTxbx()` Count of textboxes in shape (undo doc only).
    `short` | `getFlags()` Get the flags field for the FSPA record.
    `static int` | `getSize()` Size of record
    `int` | `getSpid()` Shape Identifier.
    `byte` | `getWr()` Text wrapping mode
    `byte` | `getWrk()` Text wrapping mode type (valid only for wrapping modes 2 and 4
    `int` | `getXaLeft()` Left of rectangle enclosing shape relative to the origin of the shape.
    `int` | `getXaRight()` Right of rectangle enclosing shape relative to the origin of the shape.
    `int` | `getYaBottom()` Bottom of the rectangle enclosing shape relative to the origin of the shape.
    `int` | `getYaTop()` Top of rectangle enclosing shape relative to the origin of the shape.
    `boolean` | `isFAnchorLock()`
    `boolean` | `isFBelowText()`
    `boolean` | `isFHdr()` 1 in the undo doc when shape is from the header doc, 0 otherwise (undefined when not in the undo doc)
    `boolean` | `isFRcaSimple()` When set, temporarily overrides bx, by, forcing the xaLeft, xaRight, yaTop, and yaBottom fields to all be page relative.
    `void` | `serialize(byte[] data, int offset)`
    `void` | `setBx(byte value)` Sets the bx field value.
    `void` | `setBy(byte value)` Sets the by field value.
    `void` | `setCTxbx(int field_7_cTxbx)` Count of textboxes in shape (undo doc only).
    `void` | `setFAnchorLock(boolean value)` Sets the fAnchorLock field value.
    `void` | `setFBelowText(boolean value)` Sets the fBelowText field value.
    `void` | `setFHdr(boolean value)` Sets the fHdr field value.
    `void` | `setFlags(short field_6_flags)` Set the flags field for the FSPA record.
    `void` | `setFRcaSimple(boolean value)` Sets the fRcaSimple field value.
    `void` | `setSpid(int field_1_spid)` Shape Identifier.
    `void` | `setWr(byte value)` Sets the wr field value.
    `void` | `setWrk(byte value)` Sets the wrk field value.
    `void` | `setXaLeft(int field_2_xaLeft)` Left of rectangle enclosing shape relative to the origin of the shape.
    `void` | `setXaRight(int field_4_xaRight)` Right of rectangle enclosing shape relative to the origin of the shape.
    `void` | `setYaBottom(int field_5_yaBottom)` Bottom of the rectangle enclosing shape relative to the origin of the shape.
    `void` | `setYaTop(int field_3_yaTop)` Top of rectangle enclosing shape relative to the origin of the shape.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### field_1_spid

          protected int field_1_spid

    - #### field_2_xaLeft

          protected int field_2_xaLeft

    - #### field_3_yaTop

          protected int field_3_yaTop

    - #### field_4_xaRight

          protected int field_4_xaRight

    - #### field_5_yaBottom

          protected int field_5_yaBottom

    - #### field_6_flags

          protected short field_6_flags

    - #### field_7_cTxbx

          protected int field_7_cTxbx

  - ### Constructor Detail

    - #### FSPAAbstractType

          protected FSPAAbstractType()

  - ### Method Detail

    - #### fillFields

          protected void fillFields(byte[] data,
                                    int offset)

    - #### serialize

          public void serialize(byte[] data,
                                int offset)

    - #### getSize

          public static int getSize()

      Size of record

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getSpid

          @Internal
          public int getSpid()

      Shape Identifier. Used in conjunction with the office art data (found via fcDggInfo in the FIB) to find the actual data for this shape.

    - #### setSpid

          @Internal
          public void setSpid(int field_1_spid)

      Shape Identifier. Used in conjunction with the office art data (found via fcDggInfo in the FIB) to find the actual data for this shape.

    - #### getXaLeft

          @Internal
          public int getXaLeft()

      Left of rectangle enclosing shape relative to the origin of the shape.

    - #### setXaLeft

          @Internal
          public void setXaLeft(int field_2_xaLeft)

      Left of rectangle enclosing shape relative to the origin of the shape.

    - #### getYaTop

          @Internal
          public int getYaTop()

      Top of rectangle enclosing shape relative to the origin of the shape.

    - #### setYaTop

          @Internal
          public void setYaTop(int field_3_yaTop)

      Top of rectangle enclosing shape relative to the origin of the shape.

    - #### getXaRight

          @Internal
          public int getXaRight()

      Right of rectangle enclosing shape relative to the origin of the shape.

    - #### setXaRight

          @Internal
          public void setXaRight(int field_4_xaRight)

      Right of rectangle enclosing shape relative to the origin of the shape.

    - #### getYaBottom

          @Internal
          public int getYaBottom()

      Bottom of the rectangle enclosing shape relative to the origin of the shape.

    - #### setYaBottom

          @Internal
          public void setYaBottom(int field_5_yaBottom)

      Bottom of the rectangle enclosing shape relative to the origin of the shape.

    - #### getFlags

          @Internal
          public short getFlags()

      Get the flags field for the FSPA record.

    - #### setFlags

          @Internal
          public void setFlags(short field_6_flags)

      Set the flags field for the FSPA record.

    - #### getCTxbx

          @Internal
          public int getCTxbx()

      Count of textboxes in shape (undo doc only).

    - #### setCTxbx

          @Internal
          public void setCTxbx(int field_7_cTxbx)

      Count of textboxes in shape (undo doc only).

    - #### setFHdr

          @Internal
          public void setFHdr(boolean value)

      Sets the fHdr field value. 1 in the undo doc when shape is from the header doc, 0 otherwise (undefined when not in the undo doc)

    - #### isFHdr

          @Internal
          public boolean isFHdr()

      1 in the undo doc when shape is from the header doc, 0 otherwise (undefined when not in the undo doc)
      Returns:
        the fHdr field value.

    - #### setBx

          @Internal
          public void setBx(byte value)

      Sets the bx field value. X position of shape relative to anchor CP

    - #### getBx

          @Internal
          public byte getBx()

      X position of shape relative to anchor CP
      Returns:
        the bx field value.

    - #### setBy

          @Internal
          public void setBy(byte value)

      Sets the by field value. Y position of shape relative to anchor CP

    - #### getBy

          @Internal
          public byte getBy()

      Y position of shape relative to anchor CP
      Returns:
        the by field value.

    - #### setWr

          @Internal
          public void setWr(byte value)

      Sets the wr field value. Text wrapping mode

    - #### getWr

          @Internal
          public byte getWr()

      Text wrapping mode
      Returns:
        the wr field value.

    - #### setWrk

          @Internal
          public void setWrk(byte value)

      Sets the wrk field value. Text wrapping mode type (valid only for wrapping modes 2 and 4

    - #### getWrk

          @Internal
          public byte getWrk()

      Text wrapping mode type (valid only for wrapping modes 2 and 4
      Returns:
        the wrk field value.

    - #### setFRcaSimple

          @Internal
          public void setFRcaSimple(boolean value)

      Sets the fRcaSimple field value. When set, temporarily overrides bx, by, forcing the xaLeft, xaRight, yaTop, and yaBottom fields to all be page relative.

    - #### isFRcaSimple

          @Internal
          public boolean isFRcaSimple()

      When set, temporarily overrides bx, by, forcing the xaLeft, xaRight, yaTop, and yaBottom fields to all be page relative.
      Returns:
        the fRcaSimple field value.

    - #### setFBelowText

          @Internal
          public void setFBelowText(boolean value)

      Sets the fBelowText field value.

    - #### isFBelowText

          @Internal
          public boolean isFBelowText()

      Returns:
        the fBelowText field value.

    - #### setFAnchorLock

          @Internal
          public void setFAnchorLock(boolean value)

      Sets the fAnchorLock field value.

    - #### isFAnchorLock

          @Internal
          public boolean isFAnchorLock()

      Returns:
        the fAnchorLock field value.

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.